 dc.l $FFE000, RESET
 dcb.l $1A,RESERV3F
 dc.l  RESERV3F, RESERV3F, VBLANK
 dcb.l $21,RESERV3F
 dc.b 'SEGA MEGA DRIVE '
 dc.b 'ELEKTRO 2013.JUN'
 dc.b 'Sin Wave Test                                   '
 dc.b 'Sin Wave Test                                   '
 dc.b 'GM 00000000-01'
 dc.w $540C
 dc.b 'JUE             '
 dc.l 0, $FFFFF, $FF0000, $FFFFFF
 dcb.b $C,$20;dc.l $5241E020 ; sram
 ;dc.l $200000
 ;dc.l $203FFF
 dc.b 'Testing Utility                         JUE             '

; =============== S U B R O U T I N E =======================================

VBLANK:
 rte

; =============== S U B R O U T I N E =======================================

RESERV3F:
 nop
 rte

; =============== S U B R O U T I N E =======================================

RESET:
 tst.l   ($A10008).l
 bne.s   loc_25E
 tst.w   ($A1000C).l

loc_25E:
 bne.s   loc_2DC
 lea     word_2E2,a5     ; d5
 movem.w (a5)+,d5-d7
 movem.l (a5)+,a0-a4
 move.b  -$10FF(a1),d0   ; read from A10000
 andi.b  #$F,d0
 beq.s   loc_27E
 move.l  #'SEGA',$2F00(a1)

loc_27E:
 move.w  (a4),d0
 moveq   #0,d0
 movea.l d0,a6
 move.l  a6,usp
 moveq   #$17,d1

loc_288:
 move.b  (a5)+,d5
 move.w  d5,(a4)
 add.w   d7,d5
 dbf     d1,loc_288
 move.l  (a5)+,(a4)
 move.w  d0,(a3)
 move.w  d7,(a1)
 move.w  d7,(a2)

loc_29A:
 btst    d0,(a1)
 bne.s   loc_29A
 moveq   #$25,d2 ; '%'

loc_2A0:
 move.b  (a5)+,(a0)+
 dbf     d2,loc_2A0
 move.w  d0,(a2)
 move.w  d0,(a1)
 move.w  d7,(a2)

loc_2AC:
 move.l  d0,-(a6)
 dbf     d6,loc_2AC      ; clear M68k RAM
 move.l  (a5)+,(a4)
 move.l  (a5)+,(a4)      ; CRAM
 moveq   #$1F,d3

loc_2B8:
 move.l  d0,(a3)
 dbf     d3,loc_2B8
 move.l  (a5)+,(a4)      ; VSRAM
 moveq   #$13,d4

loc_2C2:
 move.l  d0,(a3)
 dbf     d4,loc_2C2
 moveq   #3,d5

loc_2CA:
 move.b  (a5)+,$11(a3)
 dbf     d5,loc_2CA
 move.w  d0,(a2)
 movem.l (a6),d0-a6
 move    #$2700,sr

loc_2DC:
 jmp     player_start

; ---------------------------------------------------------------------------
word_2E2:       dc.w $8000
 ; d5
 dc.w $3FFF              ; d6 M68k ram size for zero memset
 dc.w $100               ; d7
 dc.l $A00000            ; a0
 dc.l $A11100            ; a1
 dc.l $A11200            ; a2
 dc.l $C00000            ; a3
 dc.l $C00004            ; a4
 dc.b 4                  ; vdp registers
 dc.b $14
 dc.b $30
 dc.b $3C
 dc.b 7
 dc.b $6C
 dc.b 0
 dc.b 0
 dc.b 0
 dc.b 0
 dc.b $FF
 dc.b 0
 dc.b $81
 dc.b $37
 dc.b 0
 dc.b 1
 dc.b 1
 dc.b 0
 dc.b 0
 dc.b $FF
 dc.b $FF
 dc.b 0
 dc.b 0
 dc.b $80
 dc.l $40000080          ; DMA -> VRAM offset 0
 dc.b $AF                ; A00000-A00026
 dc.b 1
 dc.b $D9
 dc.b $1F
 dc.b $11
 dc.b $27
 dc.b 0
 dc.b $21
 dc.b $26
 dc.b 0
 dc.b $F9
 dc.b $77
 dc.b $ED
 dc.b $B0
 dc.b $DD
 dc.b $E1
 dc.b $FD
 dc.b $E1
 dc.b $ED
 dc.b $47
 dc.b $ED
 dc.b $4F
 dc.b $D1
 dc.b $E1
 dc.b $F1
 dc.b 8
 dc.b $D9
 dc.b $C1
 dc.b $D1
 dc.b $E1
 dc.b $F1
 dc.b $F9
 dc.b $F3
 dc.b $ED
 dc.b $56
 dc.b $36
 dc.b $E9
 dc.b $E9
 dc.l $81048F02          ; display, vblank, dma OFF
 ; rows 28
 ; autoincrenent 2
 dc.l $C0000000          ; CRAM from offset 0
 dc.l $40000010          ; VSRAM from offset 0
 dc.b $9F
 dc.b $BF
 dc.b $DF
 dc.b $FF

player_start:
 link a6,#0
 jsr  loadz80
 jsr  startz80
qweqweqwe:
 bra  qweqweqwe

BUSREQ EQU  $A11100
BUSRES EQU  $A11200
Z80RAM EQU  $A00000

Z80CODE:
 incbin 'z80.out'
 even
Z80END:

loadz80:
 move.l    a1,-(sp)
 move.w    sr,-(SP)
 or.w #$0700,sr

 move.w    #$100,BUSRES
 jsr  holdz80

 lea  Z80CODE,a0
 lea  Z80END,a1
 move.l    a1,d0
 sub.l     a0,d0
 subq #1,d0
 lea  Z80RAM,a1
lzlp1
 move.b    (a0)+,(a1)+
 dbra d0,lzlp1
 
 move.w    (sp)+,sr
 move.l    (sp)+,a1
 rts

startz80:
 move.w    sr,-(SP)
 or.w #$0700,sr

 move.w    #$0,BUSRES
 move.l    #15,d0
szlp:
 subq.l    #1,d0
 bne.s     szlp
 move.w    #$0,BUSREQ
 move.w    #$100,BUSRES

 move.w    (sp)+,sr
 rts

holdz80:
 move.w    #$100,BUSREQ
hzlp:
 btst.b    #0,BUSREQ
 bne.s     hzlp

 rts